Index: /palm/trunk/SOURCE/poismg_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poismg_mod.f90	(revision 2036)
+++ /palm/trunk/SOURCE/poismg_mod.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented (stll error in optimized multigrid)
 ! 
 ! Former revisions:
@@ -262,5 +262,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  f1_mg, f2_mg, f3_mg
+           ONLY:  f1_mg, f2_mg, f3_mg, rho_air_mg
 
        USE control_parameters,                                                 &
@@ -309,7 +309,7 @@
                 kp1 = k-ind_even_odd
                 r(k,j,i) = f_mg(k,j,i)                                         &
-                      - ddx2_mg(l) *                                           &
+                      - rho_air_mg(k,l) * ddx2_mg(l) *                         &
                       ( p_mg(k,j,i+1) +  p_mg(k,j,i-1)  )                      &
-                      - ddy2_mg(l) *                                           &
+                      - rho_air_mg(k,l) * ddy2_mg(l) *                         &
                       ( p_mg(k,j+1,i) + p_mg(k,j-1,i)  )                       &
                       - f2_mg_b(k,l) * p_mg(kp1,j,i)                           &
@@ -322,7 +322,7 @@
                 kp1 = k+ind_even_odd+1
                 r(k,j,i) = f_mg(k,j,i)                                         &
-                      - ddx2_mg(l) *                                           &
+                      - rho_air_mg(k,l) * ddx2_mg(l) *                         &
                       ( p_mg(k,j,i+1) +  p_mg(k,j,i-1)  )                      &
-                      - ddy2_mg(l) *                                           &
+                      - rho_air_mg(k,l) * ddy2_mg(l) *                         &
                       ( p_mg(k,j+1,i) + p_mg(k,j-1,i)  )                       &
                       - f2_mg_b(k,l) * p_mg(kp1,j,i)                           &
@@ -693,5 +693,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  f1_mg, f2_mg, f3_mg
+           ONLY:  f1_mg, f2_mg, f3_mg, rho_air_mg
 
        USE control_parameters,                                                 &
@@ -755,7 +755,7 @@
                          kp1 = k-ind_even_odd
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -774,7 +774,7 @@
                          kp1 = k-ind_even_odd
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -793,7 +793,7 @@
                          kp1 = k+ind_even_odd+1
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -812,7 +812,7 @@
                          kp1 = k+ind_even_odd+1
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -843,7 +843,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -852,7 +852,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -869,7 +869,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -878,7 +878,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -895,7 +895,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -904,7 +904,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -921,7 +921,7 @@
                          j   = jj
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
@@ -930,7 +930,7 @@
                          j = jj+2
                          p_mg(k,j,i) = 1.0_wp / f1_mg_b(k,l) * (               &
-                                 ddx2_mg(l) *                                  &
+                                 rho_air_mg(k,l) * ddx2_mg(l) *                &
                                ( p_mg(k,j,i+1) + p_mg(k,j,i-1) )               &
-                               + ddy2_mg(l) *                                  &
+                               + rho_air_mg(k,l) * ddy2_mg(l) *                &
                                ( p_mg(k,j+1,i) + p_mg(k,j-1,i) )               &
                                + f2_mg_b(k,l) * p_mg(kp1,j,i)                  &
Index: /palm/trunk/SOURCE/poismg_noopt.f90
===================================================================
--- /palm/trunk/SOURCE/poismg_noopt.f90	(revision 2036)
+++ /palm/trunk/SOURCE/poismg_noopt.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -268,5 +268,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  f1_mg, f2_mg, f3_mg
+        ONLY:  f1_mg, f2_mg, f3_mg, rho_air_mg
 
     USE control_parameters,                                                    &
@@ -339,10 +339,10 @@
           DO  k = nzb+1, nzt_mg(l)
              r(k,j,i) = f_mg(k,j,i)                                         &
-                        - ddx2_mg(l) *                                      &
+                        - rho_air_mg(k,l) * ddx2_mg(l) *                    &
                             ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                           ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                               p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                           ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                        - ddy2_mg(l) *                                      &
+                        - rho_air_mg(k,l) * ddy2_mg(l) *                    &
                             ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                           ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -745,5 +745,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  f1_mg, f2_mg, f3_mg
+        ONLY:  f1_mg, f2_mg, f3_mg, rho_air_mg
 
     USE control_parameters,                                                    &
@@ -846,10 +846,10 @@
 
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -869,10 +869,10 @@
                    DO  k = nzb+1, nzt_mg(l), 2 
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -892,10 +892,10 @@
                    DO  k = nzb+2, nzt_mg(l), 2
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -915,10 +915,10 @@
                    DO  k = nzb+2, nzt_mg(l), 2
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -947,10 +947,10 @@
                       j = jj
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -964,10 +964,10 @@
                       j = jj+2
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -986,10 +986,10 @@
                       j =jj
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -1003,10 +1003,10 @@
                       j = jj+2
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -1025,10 +1025,10 @@
                       j =jj
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -1042,10 +1042,10 @@
                       j = jj+2
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -1064,10 +1064,10 @@
                       j =jj
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
@@ -1081,10 +1081,10 @@
                       j = jj+2
                       p_mg(k,j,i) = 1.0_wp / f1_mg(k,l) * (                    &
-                             ddx2_mg(l) *                                      &
+                             rho_air_mg(k,l) * ddx2_mg(l) *                    &
                                ( p_mg(k,j,i+1) + IBITS( flags(k,j,i), 5, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i+1) ) + &
                                  p_mg(k,j,i-1) + IBITS( flags(k,j,i), 4, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j,i-1) ) ) &
-                           + ddy2_mg(l) *                                      &
+                           + rho_air_mg(k,l) * ddy2_mg(l) *                    &
                                ( p_mg(k,j+1,i) + IBITS( flags(k,j,i), 3, 1 ) * &
                                              ( p_mg(k,j,i) - p_mg(k,j+1,i) ) + &
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 2036)
+++ /palm/trunk/SOURCE/pres.f90	(revision 2037)
@@ -20,5 +20,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Anelastic approximation implemented
 ! 
 ! Former revisions:
@@ -128,5 +128,6 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  d, ddzu, ddzu_pres, ddzw, dzw, p, p_loc, tend, u, v, w
+        ONLY:  d, ddzu, ddzu_pres, ddzw, dzw, p, p_loc, rho_air, rho_air_zw,   &
+               tend, u, v, w
 
     USE control_parameters,                                                    &
@@ -399,8 +400,9 @@
        DO  j = nys, nyn
           DO  k = nzb_s_inner(j,i)+1, nzt
-             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * ddx + &
-                          ( v(k,j+1,i) - v(k,j,i) ) * ddy + &
-                          ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k) ) * ddt_3d      &
-                                                                * d_weight_pres 
+             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +       &
+                          ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +       &
+                          ( w(k,j,i)   * rho_air_zw(k) -                       &
+                            w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)           &
+                        ) * ddt_3d * d_weight_pres 
           ENDDO
 !
@@ -427,8 +429,9 @@
        DO  j = nys, nyn
           DO  k = 1, nzt
-             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * ddx +             &
-                        ( v(k,j+1,i) - v(k,j,i) ) * ddy +               &
-                        ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k) ) * ddt_3d  &
-                        * d_weight_pres * rflags_s_inner(k,j,i)
+             d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +       &
+                          ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +       &
+                          ( w(k,j,i)   * rho_air_zw(k) -                       &
+                            w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)           &
+                        ) * ddt_3d * d_weight_pres * rflags_s_inner(k,j,i)
           ENDDO
        ENDDO
@@ -808,7 +811,8 @@
           DO  j = nys, nyn
              DO  k = nzb_s_inner(j,i)+1, nzt
-                d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * ddx +                   &
-                           ( v(k,j+1,i) - v(k,j,i) ) * ddy +                   &
-                           ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)
+             d(k,j,i) = ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +         &
+                        ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +         &
+                        ( w(k,j,i)   * rho_air_zw(k) -                         &
+                          w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)
              ENDDO
              DO  k = nzb+1, nzt
@@ -823,8 +827,9 @@
           DO  j = nys, nyn
              DO  k = 1, nzt
-                   d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * ddx +              &
-                                ( v(k,j+1,i) - v(k,j,i) ) * ddy +              &
-                                ( w(k,j,i) - w(k-1,j,i) ) * ddzw(k)            &
-                              ) * rflags_s_inner(k,j,i)
+                d(k,j,i) = ( ( u(k,j,i+1) - u(k,j,i) ) * rho_air(k) * ddx +    &
+                             ( v(k,j+1,i) - v(k,j,i) ) * rho_air(k) * ddy +    &
+                             ( w(k,j,i)   * rho_air_zw(k) -                    &
+                               w(k-1,j,i) * rho_air_zw(k-1) ) * ddzw(k)        &
+                           ) * rflags_s_inner(k,j,i)
              ENDDO
           ENDDO
